// Copyright 2022 Risc0, Inc.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

use crate::zkp::taps::{Combo, Register, RegisterGroup, Taps};

pub const RISCV_TAPS: &'static Taps = &Taps {
    registers: &[
        Register {
            group: RegisterGroup::Accum,
            offset: 0,
            back: &[0, 1],
            combo_id: 1,
        },
        Register {
            group: RegisterGroup::Accum,
            offset: 1,
            back: &[0, 1],
            combo_id: 1,
        },
        Register {
            group: RegisterGroup::Accum,
            offset: 2,
            back: &[0, 1],
            combo_id: 1,
        },
        Register {
            group: RegisterGroup::Accum,
            offset: 3,
            back: &[0, 1],
            combo_id: 1,
        },
        Register {
            group: RegisterGroup::Accum,
            offset: 4,
            back: &[0, 1],
            combo_id: 1,
        },
        Register {
            group: RegisterGroup::Accum,
            offset: 5,
            back: &[0, 1],
            combo_id: 1,
        },
        Register {
            group: RegisterGroup::Accum,
            offset: 6,
            back: &[0, 1],
            combo_id: 1,
        },
        Register {
            group: RegisterGroup::Accum,
            offset: 7,
            back: &[0, 1],
            combo_id: 1,
        },
        Register {
            group: RegisterGroup::Accum,
            offset: 8,
            back: &[0],
            combo_id: 0,
        },
        Register {
            group: RegisterGroup::Accum,
            offset: 9,
            back: &[0],
            combo_id: 0,
        },
        Register {
            group: RegisterGroup::Code,
            offset: 0,
            back: &[0],
            combo_id: 0,
        },
        Register {
            group: RegisterGroup::Code,
            offset: 1,
            back: &[0],
            combo_id: 0,
        },
        Register {
            group: RegisterGroup::Code,
            offset: 2,
            back: &[0],
            combo_id: 0,
        },
        Register {
            group: RegisterGroup::Code,
            offset: 3,
            back: &[0],
            combo_id: 0,
        },
        Register {
            group: RegisterGroup::Code,
            offset: 4,
            back: &[0],
            combo_id: 0,
        },
        Register {
            group: RegisterGroup::Code,
            offset: 5,
            back: &[0],
            combo_id: 0,
        },
        Register {
            group: RegisterGroup::Code,
            offset: 6,
            back: &[0],
            combo_id: 0,
        },
        Register {
            group: RegisterGroup::Code,
            offset: 7,
            back: &[0],
            combo_id: 0,
        },
        Register {
            group: RegisterGroup::Code,
            offset: 8,
            back: &[0],
            combo_id: 0,
        },
        Register {
            group: RegisterGroup::Code,
            offset: 9,
            back: &[0],
            combo_id: 0,
        },
        Register {
            group: RegisterGroup::Code,
            offset: 10,
            back: &[0],
            combo_id: 0,
        },
        Register {
            group: RegisterGroup::Code,
            offset: 11,
            back: &[0],
            combo_id: 0,
        },
        Register {
            group: RegisterGroup::Code,
            offset: 12,
            back: &[0],
            combo_id: 0,
        },
        Register {
            group: RegisterGroup::Code,
            offset: 13,
            back: &[0],
            combo_id: 0,
        },
        Register {
            group: RegisterGroup::Code,
            offset: 14,
            back: &[0],
            combo_id: 0,
        },
        Register {
            group: RegisterGroup::Code,
            offset: 15,
            back: &[0],
            combo_id: 0,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 0,
            back: &[0, 1, 2, 3, 4, 68],
            combo_id: 2,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 1,
            back: &[0, 1, 2, 3, 4, 68],
            combo_id: 2,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 2,
            back: &[0, 1, 2, 3, 4, 68],
            combo_id: 2,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 3,
            back: &[0, 1, 2, 3, 4, 68],
            combo_id: 2,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 4,
            back: &[0, 1, 2, 3, 4, 68],
            combo_id: 2,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 5,
            back: &[0, 1, 2, 3, 4, 68],
            combo_id: 2,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 6,
            back: &[0, 1, 2, 3, 4, 68],
            combo_id: 2,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 7,
            back: &[0, 1, 2, 3, 4, 68],
            combo_id: 2,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 8,
            back: &[0, 1, 2, 3, 4, 68],
            combo_id: 2,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 9,
            back: &[0, 1, 2, 3, 4, 68],
            combo_id: 2,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 10,
            back: &[0, 1, 2, 3, 4, 68],
            combo_id: 2,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 11,
            back: &[0, 1, 2, 3, 4, 68],
            combo_id: 2,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 12,
            back: &[0, 1, 2, 3, 4, 68],
            combo_id: 2,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 13,
            back: &[0, 1, 2, 3, 4, 68],
            combo_id: 2,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 14,
            back: &[0, 1, 2, 3, 4, 68],
            combo_id: 2,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 15,
            back: &[0, 1, 2, 3, 4, 68],
            combo_id: 2,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 16,
            back: &[0, 1, 2, 3, 4, 68],
            combo_id: 2,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 17,
            back: &[0, 1, 2, 3, 4, 68],
            combo_id: 2,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 18,
            back: &[0, 1, 2, 3, 4, 68],
            combo_id: 2,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 19,
            back: &[0, 1, 2, 3, 4, 68],
            combo_id: 2,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 20,
            back: &[0, 1, 2, 3, 4, 68],
            combo_id: 2,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 21,
            back: &[0, 1, 2, 3, 4, 68],
            combo_id: 2,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 22,
            back: &[0, 1, 2, 3, 4, 68],
            combo_id: 2,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 23,
            back: &[0, 1, 2, 3, 4, 68],
            combo_id: 2,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 24,
            back: &[0, 1, 2, 3, 4, 68],
            combo_id: 2,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 25,
            back: &[0, 1, 2, 3, 4, 68],
            combo_id: 2,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 26,
            back: &[0, 1, 2, 3, 4, 68],
            combo_id: 2,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 27,
            back: &[0, 1, 2, 3, 4, 68],
            combo_id: 2,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 28,
            back: &[0, 1, 2, 3, 4, 68],
            combo_id: 2,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 29,
            back: &[0, 1, 2, 3, 4, 68],
            combo_id: 2,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 30,
            back: &[0, 1, 2, 3, 4, 68],
            combo_id: 2,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 31,
            back: &[0, 1, 2, 3, 4, 68],
            combo_id: 2,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 32,
            back: &[0, 1, 2, 3, 4, 68],
            combo_id: 2,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 33,
            back: &[0, 1, 2, 3, 4, 68],
            combo_id: 2,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 34,
            back: &[0, 1, 2, 3, 4, 68],
            combo_id: 2,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 35,
            back: &[0, 1, 2, 3, 4, 68],
            combo_id: 2,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 36,
            back: &[0, 1, 2, 3, 4, 68],
            combo_id: 2,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 37,
            back: &[0, 1, 2, 3, 4, 68],
            combo_id: 2,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 38,
            back: &[0, 1, 2, 3, 4, 68],
            combo_id: 2,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 39,
            back: &[0, 1, 2, 3, 4, 68],
            combo_id: 2,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 40,
            back: &[0, 1, 2, 3, 4, 68],
            combo_id: 2,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 41,
            back: &[0, 1, 2, 3, 4, 68],
            combo_id: 2,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 42,
            back: &[0, 1, 2, 3, 4, 68],
            combo_id: 2,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 43,
            back: &[0, 1, 2, 3, 4, 68],
            combo_id: 2,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 44,
            back: &[0, 1, 2, 3, 4, 68],
            combo_id: 2,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 45,
            back: &[0, 1, 2, 3, 4, 68],
            combo_id: 2,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 46,
            back: &[0, 1, 2, 3, 4, 68],
            combo_id: 2,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 47,
            back: &[0, 1, 2, 3, 4, 68],
            combo_id: 2,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 48,
            back: &[0, 1, 2, 3, 4, 68],
            combo_id: 2,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 49,
            back: &[0, 1, 2, 3, 4, 68],
            combo_id: 2,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 50,
            back: &[0, 1, 2, 3, 4, 68],
            combo_id: 2,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 51,
            back: &[0, 1, 2, 3, 4, 68],
            combo_id: 2,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 52,
            back: &[0, 1, 2, 3, 4, 68],
            combo_id: 2,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 53,
            back: &[0, 1, 2, 3, 4, 68],
            combo_id: 2,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 54,
            back: &[0, 1, 2, 3, 4, 68],
            combo_id: 2,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 55,
            back: &[0, 1, 2, 3, 4, 68],
            combo_id: 2,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 56,
            back: &[0, 1, 2, 3, 4, 68],
            combo_id: 2,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 57,
            back: &[0, 1, 2, 3, 4, 68],
            combo_id: 2,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 58,
            back: &[0, 1, 2, 3, 4, 68],
            combo_id: 2,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 59,
            back: &[0, 1, 2, 3, 4, 68],
            combo_id: 2,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 60,
            back: &[0, 1, 2, 3, 4, 68],
            combo_id: 2,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 61,
            back: &[0, 1, 2, 3, 4, 68],
            combo_id: 2,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 62,
            back: &[0, 1, 2, 3, 4, 68],
            combo_id: 2,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 63,
            back: &[0, 1, 2, 3, 4, 68],
            combo_id: 2,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 64,
            back: &[0, 1, 2, 3, 7, 15, 16],
            combo_id: 3,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 65,
            back: &[0, 1, 2, 3, 7, 15, 16],
            combo_id: 3,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 66,
            back: &[0, 1, 2, 3, 7, 15, 16],
            combo_id: 3,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 67,
            back: &[0, 1, 2, 3, 7, 15, 16],
            combo_id: 3,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 68,
            back: &[0, 1, 2, 3, 7, 15, 16],
            combo_id: 3,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 69,
            back: &[0, 1, 2, 3, 7, 15, 16],
            combo_id: 3,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 70,
            back: &[0, 1, 2, 3, 7, 15, 16],
            combo_id: 3,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 71,
            back: &[0, 1, 2, 3, 7, 15, 16],
            combo_id: 3,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 72,
            back: &[0, 1, 2, 3, 7, 15, 16],
            combo_id: 3,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 73,
            back: &[0, 1, 2, 3, 7, 15, 16],
            combo_id: 3,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 74,
            back: &[0, 1, 2, 3, 7, 15, 16],
            combo_id: 3,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 75,
            back: &[0, 1, 2, 3, 7, 15, 16],
            combo_id: 3,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 76,
            back: &[0, 1, 2, 3, 7, 15, 16],
            combo_id: 3,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 77,
            back: &[0, 1, 2, 3, 7, 15, 16],
            combo_id: 3,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 78,
            back: &[0, 1, 2, 3, 7, 15, 16],
            combo_id: 3,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 79,
            back: &[0, 1, 2, 3, 7, 15, 16],
            combo_id: 3,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 80,
            back: &[0, 1, 2, 3, 7, 15, 16],
            combo_id: 3,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 81,
            back: &[0, 1, 2, 3, 7, 15, 16],
            combo_id: 3,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 82,
            back: &[0, 1, 2, 3, 7, 15, 16],
            combo_id: 3,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 83,
            back: &[0, 1, 2, 3, 7, 15, 16],
            combo_id: 3,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 84,
            back: &[0, 1, 2, 3, 7, 15, 16],
            combo_id: 3,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 85,
            back: &[0, 1, 2, 3, 7, 15, 16],
            combo_id: 3,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 86,
            back: &[0, 1, 2, 3, 7, 15, 16],
            combo_id: 3,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 87,
            back: &[0, 1, 2, 3, 7, 15, 16],
            combo_id: 3,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 88,
            back: &[0, 1, 2, 3, 7, 15, 16],
            combo_id: 3,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 89,
            back: &[0, 1, 2, 3, 7, 15, 16],
            combo_id: 3,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 90,
            back: &[0, 1, 2, 3, 7, 15, 16],
            combo_id: 3,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 91,
            back: &[0, 1, 2, 3, 7, 15, 16],
            combo_id: 3,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 92,
            back: &[0, 1, 2, 3, 7, 15, 16],
            combo_id: 3,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 93,
            back: &[0, 1, 2, 3, 7, 15, 16],
            combo_id: 3,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 94,
            back: &[0, 1, 2, 3, 7, 15, 16],
            combo_id: 3,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 95,
            back: &[0, 1, 2, 3, 7, 15, 16],
            combo_id: 3,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 96,
            back: &[0, 1],
            combo_id: 1,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 97,
            back: &[0, 1],
            combo_id: 1,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 98,
            back: &[0, 1],
            combo_id: 1,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 99,
            back: &[0],
            combo_id: 0,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 100,
            back: &[0, 1],
            combo_id: 1,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 101,
            back: &[0, 1],
            combo_id: 1,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 102,
            back: &[0, 1],
            combo_id: 1,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 103,
            back: &[0, 1],
            combo_id: 1,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 104,
            back: &[0, 1],
            combo_id: 1,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 105,
            back: &[0, 1],
            combo_id: 1,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 106,
            back: &[0],
            combo_id: 0,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 107,
            back: &[0],
            combo_id: 0,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 108,
            back: &[0],
            combo_id: 0,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 109,
            back: &[0],
            combo_id: 0,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 110,
            back: &[0],
            combo_id: 0,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 111,
            back: &[0],
            combo_id: 0,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 112,
            back: &[0],
            combo_id: 0,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 113,
            back: &[0],
            combo_id: 0,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 114,
            back: &[0, 1],
            combo_id: 1,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 115,
            back: &[0, 1],
            combo_id: 1,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 116,
            back: &[0, 1],
            combo_id: 1,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 117,
            back: &[0, 1],
            combo_id: 1,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 118,
            back: &[0, 1],
            combo_id: 1,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 119,
            back: &[0, 1],
            combo_id: 1,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 120,
            back: &[0, 1],
            combo_id: 1,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 121,
            back: &[0],
            combo_id: 0,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 122,
            back: &[0, 1],
            combo_id: 1,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 123,
            back: &[0, 1],
            combo_id: 1,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 124,
            back: &[0, 1],
            combo_id: 1,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 125,
            back: &[0, 1],
            combo_id: 1,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 126,
            back: &[0, 1],
            combo_id: 1,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 127,
            back: &[0, 1],
            combo_id: 1,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 128,
            back: &[0],
            combo_id: 0,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 129,
            back: &[0, 4],
            combo_id: 4,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 130,
            back: &[0, 4],
            combo_id: 4,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 131,
            back: &[0],
            combo_id: 0,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 132,
            back: &[0, 1],
            combo_id: 1,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 133,
            back: &[0],
            combo_id: 0,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 134,
            back: &[0],
            combo_id: 0,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 135,
            back: &[0],
            combo_id: 0,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 136,
            back: &[0],
            combo_id: 0,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 137,
            back: &[0],
            combo_id: 0,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 138,
            back: &[0],
            combo_id: 0,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 139,
            back: &[0, 1],
            combo_id: 1,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 140,
            back: &[0, 1],
            combo_id: 1,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 141,
            back: &[0, 1],
            combo_id: 1,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 142,
            back: &[0, 1],
            combo_id: 1,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 143,
            back: &[0, 1],
            combo_id: 1,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 144,
            back: &[0, 1],
            combo_id: 1,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 145,
            back: &[0, 1],
            combo_id: 1,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 146,
            back: &[0, 1],
            combo_id: 1,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 147,
            back: &[0],
            combo_id: 0,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 148,
            back: &[0, 1],
            combo_id: 1,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 149,
            back: &[0],
            combo_id: 0,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 150,
            back: &[0],
            combo_id: 0,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 151,
            back: &[0],
            combo_id: 0,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 152,
            back: &[0],
            combo_id: 0,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 153,
            back: &[0],
            combo_id: 0,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 154,
            back: &[0],
            combo_id: 0,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 155,
            back: &[0],
            combo_id: 0,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 156,
            back: &[0],
            combo_id: 0,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 157,
            back: &[0],
            combo_id: 0,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 158,
            back: &[0],
            combo_id: 0,
        },
        Register {
            group: RegisterGroup::Data,
            offset: 159,
            back: &[0],
            combo_id: 0,
        },
    ],
    combos: &[
        Combo { back: &[0] },
        Combo { back: &[0, 1] },
        Combo {
            back: &[0, 1, 2, 3, 4, 68],
        },
        Combo {
            back: &[0, 1, 2, 3, 7, 15, 16],
        },
        Combo { back: &[0, 4] },
    ],
};
